/*
		"ATtiny13A" memory use summary [bytes]:
		Segment   Begin    End      Code   Data   Used    Size   Use%
		---------------------------------------------------------------
		[.cseg] 0x000000 0x000256    598      0    598    1024  58.4%
		[.dseg] 0x000060 0x000062      0      2      2      64   3.1%
		[.eseg] 0x000000 0x000000      0      0      0      64   0.0%
		Assembly complete, 0 errors. 0 warnings
*/

;===================================
;    IR-  
; RC5
;				 
;					 
;	____	 _   _   _   _     _   _ _     _   _   _ _   _     _   _
;		|___| |_| |_| |_| |_ _| |_|   |_ _| |_| |_|   |_| |_ _| |_| |_|
;			| 1 | 1 | 1 | 1 | 0 | 0 | 1 | 0 | 0 | 0 | 1 | 1 | 0 | 0 |
;			    |       |                |
;			  2            5                  4 
;	
;								
;							
;	  0			  1			--
;	  MAX			  2			- - -
;	  MIN			  3			-- - - -
;	 +				  4			   
;	 -				  5			   
;
;
;
;.DEVICE ATTINY13
;===================================
;    
;===================================
;PortB
.EQU	LED_OUT		=	0					;    
//.EQU	IN_IR		=	1					; {  IR}
.EQU	OUT1		=	2					; 
.EQU	OUT2		=	3					; 
.EQU	OUT3		=	4					; 
//.EQU	OUT4		=	5					;    Reset
;===================================
;  
;===================================
.EQU	NumPr			=	6				; -   ,  2.
.EQU	NumMid			=	50				;     {0}
.EQU	R_Count			=	100				; -   . . 
.EQU	F_CPU			=	9600000			;    
.EQU	ON				=	1				; , 
.EQU	OFF				=	0				; , 
.EQU	LED_L			=	80				;  
.EQU	LED_S			=	20				;  
.EQU	LED_P			=	30				; 
;===================================
;  
;===================================
.DEF	TOV_Count		=	R1				;   (  < 10   , 10    )
.DEF	Rep_Count		=	R2				;  -   . . 
.DEF	Pult_Count		=	R3				;   
.DEF	AdrEE			=	R4				;   
.DEF	IR_TempL		=	R5				;  
.DEF	IR_TempH		=	R6				;  
.DEF	IR_EETempL		=	R7				;  
.DEF	IR_EETempH		=	R8				;  
.DEF	Lo_Ref			=	R16				;  
.DEF	Hi_Ref			=	R17				;  
.DEF	IR_Flags		=	R18				;   0b0000_0000 IR  (ZH)
.EQU	IR_New			=	0				;					 ||||_||||>	   
.EQU	IR_Key			=	1				;					 ||||_|||>	 
.EQU	IR_Tra			=	2				;					 ||||_||>	  
.EQU	IR_Rep			=	3				;					 ||||_|>	 
.DEF	Frame_Pos		=	R19				;   
.DEF	TempL			=	R20				;  
.DEF	TempH			=	R21				;  
.DEF	PrNum			=	R22				;  
.DEF	TempP3			=	R23				;    
.DEF	TempP1			=	R24				;    } 
.DEF	TempP2			=	R25				;    } 

;===================================
;    
;===================================
.DSEG
	IR_PultL	:	.BYTE 1					;  
	IR_PultH	:	.BYTE 1					;   
;===================================
;    
;===================================
.CSEG
.ORG 0
	RJMP INIT								;    
;  
	RJMP INT_0								;      1
	RETI
	RJMP TIMER_0							;    /1 = /1024
	RETI
	RETI
	RETI
	RETI
	RETI
	RETI
;===================================
;    
;===================================
INT_0:										;      1
	PUSH	TempL
	PUSH	TempH
	IN		TempL,SREG
	PUSH	TempL							;    SREG
	CPI		Frame_Pos,255					;  
	BREQ	Get_Data
	CPI		Frame_Pos,3						;  
	BREQ	Get_Standard
	CPI		Frame_Pos,0						;   
	BREQ	StartData
	RCALL	Get_CNT
	INC		Frame_Pos
INT_EX:
	POP		TempL							;    SREG
	OUT		SREG,TempL
	POP		TempH
	POP		TempL
	RETI
Get_Data:
	RCALL	Get_CNT							;  
	CP		Hi_Ref,TempH
	BRCS	Set1							;   
	CP		TempH,Lo_Ref
	BRCS	Set1							;   
Set0:
	LSL		IR_TempL						;  0
	ROL		IR_TempH
	RJMP	INT_EX
Set1:
	SEC										;  1
	ROL		IR_TempL
	ROL		IR_TempH
	RJMP	INT_EX
Get_Standard:
	RCALL	Get_CNT							;  
	MOV		Hi_Ref,TempH
	SUBI	Hi_Ref,$FE						; +2
	MOV		Lo_Ref,TempH
	SUBI	Lo_Ref,$02						; -2
	LDI		Frame_Pos,$FF
	RJMP	INT_EX
StartData:
	RCALL	Get_CNT							;  
	ORI		IR_Flags,(1<<IR_Key)			;  
	CLR		TOV_Count						;   <- 0
	SBRC	IR_Flags,IR_Rep					;    
	RJMP	SD_EX
	SBRC	IR_Flags,IR_Tra					;     
	RJMP	SD_EX
	SBI		PORTB,LED_OUT					;  ################################################
SD_EX:
	LDI		Frame_Pos,1
	RJMP	INT_EX
Get_CNT:
	IN		TempH,TCNT0						;  
	CLR		TempL
	OUT		TCNT0,TempL
	RET
;===================================
;    /1
;===================================
TIMER_0:
	PUSH	TempL
	PUSH	TempH
	IN		TempL,SREG
	PUSH	TempL							;    SREG
	SBRS	IR_Flags,IR_Key					;  
	RJMP	T0_EX							; 
	CLR		Frame_Pos
	INC		TOV_Count
	LDI		TempH,7
	CP		TOV_Count,TempH
	BRCS	NotUp
	ANDI	IR_Flags,~(1<<IR_Key)			;   $FD	=~2
	CLR		Rep_Count
	ANDI	IR_Flags,~(1<<IR_Rep)			;   $F7	=~3
	CBI		PORTB,LED_OUT					;  ###########################################
	CLR		IR_TempL
	CLR		IR_TempH
T0_EX:
	POP		TempL							;    SREG
	OUT		SREG,TempL
	POP		TempH
	POP		TempL
	RETI
NotUp:
	SBRC	IR_Flags,IR_Rep					;     
	RJMP	T0_EX
	STS		IR_PultL,IR_TempL				;   
	STS		IR_PultH,IR_TempH
	ORI		IR_Flags,(1<<IR_New)			;   
	SBRC	IR_Flags,IR_Tra					;     
	RJMP	T0_EX
	CBI		PORTB,LED_OUT					;  ###########################################
	INC		Rep_Count
	LDI		TempH,R_Count
	CP		Rep_Count,TempH
	BRCS	T0_EX
	ORI		IR_Flags,(1<<IR_Rep)			;  
	ORI		IR_Flags,(1<<IR_Tra)			;  
	RJMP	T0_EX
;===================================
;  
;===================================
StudyPult:
	SBI		PORTB,LED_OUT					;  
	LDI		ZL,1
	LDI		TempL,5							; 5  
	MOV		Pult_Count,TempL
SP_01:
	RCALL	BlinkShort						;  
	ANDI	IR_Flags,~(1<<IR_New)			;   
SP_02:
	SBRC	IR_Flags,IR_Key					;   
	RJMP	SP_02
SP_03:
	SBRS	IR_Flags,IR_New					;   
	RJMP	SP_03
	ORI		IR_Flags,(1<<IR_Rep)			;  
	CLI										;  .
	MOV		TempL,ZL
	LDS		TempH,IR_PultL
	RCALL	EEWrite
	INC		ZL
	MOV		TempL,ZL
	LDS		TempH,IR_PultH
	RCALL	EEWrite
	INC		ZL
	SEI										;  
	DEC		Pult_Count
	BRNE	SP_01
	ANDI	IR_Flags,~(1<<IR_Tra)			;  
	LDI		PrNum,NumMid					; =0
	RCALL	BlinkShort						;  
	RET
;===================================
;  
;===================================
KeyWork:
	LDI		ZL,1
	RCALL	GetEECom
	BRNE	KW_01
	LDI		TempH,NumMid					; =0
	RJMP	SDiv
KW_01:
	RCALL	GetEECom
	BRNE	KW_02
	LDI		TempH,(NumMid+NumPr/2)			; =max
	RJMP	SDiv
KW_02:
	RCALL	GetEECom
	BRNE	KW_03
	LDI		TempH,(NumMid-NumPr/2)			; =min
	RJMP	SDiv
KW_03:
	RCALL	GetEECom
	BRNE	KW_04
	MOV		TempH,PrNum						; 
	CPI		PrNum,(NumMid+NumPr/2)
	BRSH	SDiv							; >=
	INC		TempH							; +1
	RJMP	SDiv
KW_04:
	RCALL	GetEECom
	BRNE	KW_EX
	MOV		TempH,PrNum						; 
	CPI		PrNum,(NumMid-NumPr/2+1)
	BRLO	SDiv							; <
	DEC		TempH							; -1
SDiv:
	LDI		TempL,0
	MOV		PrNum,TempH						;    
	CLI										;  .
	RCALL	EEWrite							; 
	RCALL	BlinkPN							;  
	SEI										;  
KW_UP:
	ORI		IR_Flags,(1<<IR_Rep)			;  
KW_EX:
	ANDI	IR_Flags,~(1<<IR_New)			;   
	RET
;===================================
;    
;===================================
GetEECom:
	MOV		TempL,ZL
	RCALL	EERead
	MOV		IR_EETempL,TempH
	INC		ZL
	MOV		TempL,ZL
	RCALL	EERead
	MOV		IR_EETempH,TempH
	INC		ZL
	LDS		TempL,IR_PultL
	LDS		TempH,IR_PultH
	CP		TempL,IR_EETempL
	CPC		TempH,IR_EETempH
	RET
EEWrite:    
	OUT		EEAR,TempL						;    
	OUT		EEDR,TempH						;   ,    
    SBI		EECR,EEMWE						;  
    SBI		EECR,EEWE						;  
EEWait:
    SBIC	EECR,EEWE						;     .   
    RJMP	EEWait							;        EEWE
    RET										;   
EERead: 
	OUT		EEAR, TempL						;    
	SBI		EECR,EERE						;   
	IN		TempH, EEDR						;     
	RET										;   
;===================================
;   
;===================================
BlinkPN:	
	CPI		PrNum,(NumMid+1)
	BRSH	BPN_01							; PrNum > 101
	LDI		TempH,LED_L						;
	RCALL	BlinkLong						; 
	LDI		TempL,NumMid						;
	SUB		TempL,PrNum						;   
	CPI		TempL,0
	BREQ	BPN_EX							; 
	RJMP	BPN_02
BPN_01:
	MOV		TempL,PrNum						;   
	SUBI	TempL,NumMid
BPN_02:
	RCALL	BlinkShort						; 
	DEC		TempL							; |   
	BRNE	BPN_02							; |
BPN_EX:
	RET										;   
BlinkShort:	
	LDI		TempH,LED_S						;
BlinkLong:
	SBI		PORTB,LED_OUT					;  
	RCALL	PAUSE							; 
	CBI		PORTB,LED_OUT					;  
	LDI		TempH,LED_P						;
	RCALL	PAUSE							; 
	RET										;   
;===================================
;  
;===================================
PAUSE:
	RCALL ms_100							; |
	DEC  TempH								; |   
	BRNE PAUSE								; |
	RET										;   
ms_100:
	LDI TempP1,LOW(19200)
	LDI TempP2,HIGH(19200)
	LDI TempP3,BYTE3(19200)
LOOP:
	SBIW TempP1,1
	SBCI TempP3,0
	BRNE LOOP
	RET
;===================================
;  
;===================================
INIT: 
	LDI		TempL,LOW(RAMEND)				;     
	OUT		SPL,TempL
	CLR		TempL							;    ,  
	OUT		TCCR0A,TempL					;   / 0A, 
	LDI		TempL,(1<<CS02)|(1<<CS00)		;  /1 = /1024
	OUT		TCCR0B,TempL					;   / 0, 
	LDI		TempL,(1<<TOV0)					;   /0
	OUT		TIMSK0,TempL					; 
	LDI		TempL,(1<<LED_OUT)|(1<<OUT1)|(1<<OUT2);   /
	OUT		DDRB,TempL
//	LDI		TempL,(1<<LED_OUT)|(1<<OUT1)|(1<<OUT2)	;    
	CLR		TempL							;   0
	OUT		PORTB,TempL
	IN		TempL,MCUCR
	ANDI	TempL,$FC
	ORI		TempL,(1<<ISC01)				;  INT0   
	OUT		MCUCR,TempL						;
	CLR		TempL							;
	OUT		GIFR,TempL
	LDI		TempL,(1<<INT0)					;    INT0
	OUT		GIMSK,TempL						;
	CLR		TempL							;  
	MOV		TOV_Count,TempL
	MOV		Rep_Count,TempL
	MOV		Pult_Count,TempL
	MOV		PrNum,TempL
	MOV		AdrEE,TempL
	MOV		Frame_Pos,TempL
	MOV		IR_Flags,TempL
	RCALL	EERead							;     EEPOM
	MOV		PrNum,TempH						;   PrNum
	SEI
;===================================
;  
;===================================
START:
	SBRC	IR_Flags,IR_Tra					;   
	RCALL	StudyPult
	SBRC	IR_Flags,IR_New					;    
	RCALL	KeyWork
	CPI		PrNum,NumMid
	BREQ	PN0								; =0
	CPI		PrNum,(NumMid+1)
	BREQ	PNP1							; =1
	CPI		PrNum,(NumMid-1)
	BREQ	PNM1							; =-1
	CPI		PrNum,(NumMid+2)
	BREQ	PNP2							; =2
	CPI		PrNum,(NumMid-2)
	BREQ	PNM2							; =-2
	CPI		PrNum,(NumMid+3)
	BRSH	PNP3							; =3
	CPI		PrNum,(NumMid-3)
	BRSH	PNM3							; =-3
	RJMP	START
;===================================
;    0
;===================================
PN0:
	CBI		PORTB,OUT1						; .  1
	SBI		PORTB,OUT2						;   2
	CBI		PORTB,OUT3						; .  3
	RJMP	START
;===================================
;    1
;===================================
PNP1:
	SBI		PORTB,OUT1						;   1
	CBI		PORTB,OUT2						; .  2
	CBI		PORTB,OUT3						; .  3
	RJMP	START
;===================================
;    -1
;===================================
PNM1:
	CBI		PORTB,OUT1						; .  1
	CBI		PORTB,OUT2						; .  2
	SBI		PORTB,OUT3						;   3
	RJMP	START
;===================================
;    2
;===================================
PNP2:
	CBI		PORTB,OUT1						; .  1
	CBI		PORTB,OUT2						; .  2
	CBI		PORTB,OUT3						; .  3
	RJMP	START
;===================================
;    -2
;===================================
PNM2:
	SBI		PORTB,OUT1						;   1
	SBI		PORTB,OUT2						;   2
	SBI		PORTB,OUT3						;   3
	RJMP	START
;===================================
;    3
;===================================
PNP3:
	SBI		PORTB,OUT1						;   1
	SBI		PORTB,OUT2						;   2
	CBI		PORTB,OUT3						; .  3
	RJMP	START
;===================================
;    -3
;===================================
PNM3:
	CBI		PORTB,OUT1						; .  1
	SBI		PORTB,OUT2						;   2
	SBI		PORTB,OUT3						;   3
	RJMP	START
